package com.jdzh.jdzhandroid.ActionNotify;

import com.jdzh.jdzhandroid.Interface.IRun;
import com.jdzh.jdzhandroid.Interface.IRunT;
import com.jdzh.jdzhandroid.Result.OperateResult;

import java.util.concurrent.ConcurrentHashMap;

public class NotifyEvent {
    private static volatile NotifyEvent _instance;
    public synchronized static NotifyEvent get(){
        if(_instance == null)_instance = new NotifyEvent();
        return _instance;
    }
    private NotifyEvent(){}
    private ConcurrentHashMap<String, Object> _runMap = new ConcurrentHashMap<String, Object>();

    public void Register(String name, IRun run){
        _runMap.put(name,run);
    }

    public <T> void Register(String name, IRunT<T> run){
        _runMap.put(name,run);
    }

    public OperateResult Send(String name){
        try{
            if(_runMap.containsKey(name)&&_runMap.get(name)!=null){
                if(_runMap.get(name) instanceof IRun){
                    ((IRun)_runMap.get(name)).Run();
                    return OperateResult.CreateSuccess();
                }else{
                    return OperateResult.CreateFailed("注册类型和发送消息类型不匹配");
                }
            }else{
                return OperateResult.CreateFailed(name+"消息未注册");
            }
        }catch(Exception e){
            return OperateResult.CreateFailed(e);
        }
    }

    public <T> OperateResult Send(String name, T value){
        try{
            if(_runMap.containsKey(name)&&_runMap.get(name)!=null){
                if(_runMap.get(name) instanceof IRunT){
                    ((IRunT)_runMap.get(name)).Run(value);
                    return OperateResult.CreateSuccess();
                }else{
                    return OperateResult.CreateFailed("注册类型和发送消息类型不匹配");
                }
            }else{
                return OperateResult.CreateFailed(name+"消息未注册");
            }
        }catch(Exception e){
            return OperateResult.CreateFailed(e);
        }
    }

}
