package com.jdzh.jdzhandroid.Communication.Modbus;

import com.jdzh.jdzhandroid.DataUtil.DataConvertLib;
import com.jdzh.jdzhandroid.Log.MessageLog;
import com.licheedev.modbus4android.ModbusRespException;
import com.serotonin.modbus4j.exception.ModbusInitException;
import com.serotonin.modbus4j.exception.ModbusTransportException;

import java.util.concurrent.ExecutionException;

public class ExceptionServer {
    public ExceptionServer(String Address, int length,IExceptionHandling excpet)
    {
        try {
            int add = DataConvertLib.GetAddress(Address);
            if (add < 0) {
                MessageLog.ShowError("地址解析失败=" + Address);
                return;
            }
            if (excpet!=null) excpet.onSuccess(add);
        } catch (InterruptedException e) {
            MessageLog.ShowError("InterruptedException，Address=" + Address + ",length=" + length + ",msg:" + e.getMessage());
            if (excpet!=null) excpet.onFailure(e.getMessage());
        } catch (ExecutionException e) {
            MessageLog.ShowError("ExecutionException，Address=" + Address + ",length=" + length + ",msg:" + e.getMessage());
            if (excpet!=null) excpet.onFailure(e.getMessage());
        } catch (ModbusTransportException e) {
            MessageLog.ShowError("ModbusTransportException，Address=" + Address + ",length=" + length + ",msg:" + e.getMessage());
            if (excpet!=null) excpet.onFailure(e.getMessage());
        } catch (ModbusInitException e) {
            MessageLog.ShowError("ModbusInitException，Address=" + Address + ",length=" + length + ",msg:" + e.getMessage());
            if (excpet!=null) excpet.onFailure(e.getMessage());
        } catch (ModbusRespException e) {
            MessageLog.ShowError("ModbusRespException，Address=" + Address + ",length=" + length + ",msg:" + e.getMessage());
            if (excpet!=null) excpet.onFailure(e.getMessage());
        }

    }
}
