package com.jdzh.jdzhandroid.Task;

import com.jdzh.jdzhandroid.Log.MessageLog;

import java.util.HashMap;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class TaskManager {
    private static volatile TaskManager _Instance;
    public static TaskManager get() {
        if (_Instance == null){
            synchronized (TaskManager.class){
                if (_Instance == null){
                    _Instance = new TaskManager();
                }
            }
        }
        return _Instance;
    }

    private TaskManager() {

    }


    public long RestartInterval = 1000;
    ConcurrentHashMap<String, TaskModel> tm = new ConcurrentHashMap<>();

    private void Sleep(long millis) {
        try {
            Thread.sleep(millis);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

    public void StartLong(String Key, boolean IsRestart, ITask _thread) {
        if (!tm.containsKey(Key)) {
            tm.put(Key, new TaskModel());
            tm.get(Key).Task = _thread;
            tm.get(Key).ThreadObj = new Thread(() -> {
                MessageLog.ShowInfo("启动线程：" + Key);
                while (!tm.get(Key).IsCancel) {
                    if (IsRestart) {
                        try {
                            tm.get(Key).Task.Run();
                        } catch (Exception ex) {
                            MessageLog.ShowError("多线程：[" + Key + "] 运行发生异常，已重启,错误信息：" + ex.toString());
                            Sleep(RestartInterval);
                        }
                    } else {
                        try {
                            tm.get(Key).Task.Run();
                        } catch (Exception e) {
                            MessageLog.ShowError("多线程：[" + Key + "] 运行发生异常，已重启,错误信息：" + e.toString());
                        }
                    }
                }
                tm.remove(Key);
            });
            tm.get(Key).ThreadObj.setName(Key);
            tm.get(Key).ThreadObj.start();
        } else {
            MessageLog.ShowWarning("任务-[" + Key + "]-已存在");
        }
    }

    public void Stop(String Key) {
        if (tm.containsKey(Key)) {
            tm.get(Key).IsCancel = true;
        }
    }

    public void release(){
        for (HashMap.Entry<String, TaskModel> entry : tm.entrySet()) {
            entry.getValue().IsCancel = true;
        }
    }

}
